#include "stdafx.h"
#include "TaskIdealize.h"
#include "TaskSimulate.h"

//=================================================== 
CMRUItem :: CMRUItem( const char * pch ) { 
	m_cName=pch;
	}

//-------------------------
CMRUList :: CMRUList( const char * pchKey, int iID, HMENU hMnu, int iPos, int iLen ) { 
	m_cKey = pchKey;
	m_iID=iID;
	m_hMnu=hMnu;
	m_iPos=iPos;
	m_iLen=iLen;
	}

CMRUList :: CMRUList(){
	m_iID=-1;
	m_hMnu=NULL;
	m_iPos=-1;
	m_iLen=0;
	}
	
void CMRUList :: Set( const char * pchKey, int iID, HMENU hMnu, int iLen, int iPos ) { 
	MENUITEMINFO mii;
	mii.cbSize=sizeof(mii);
	mii.fMask=MIIM_STATE;
	
	m_cKey = pchKey;
	m_iID=iID;
	m_hMnu=hMnu;
	m_iLen=iLen;
	if( iPos==-1 ) { 
		m_iPos=0;
		while( 0!=GetMenuItemInfo(m_hMnu,m_iPos,TRUE,&mii) )
			++m_iPos;
		DWORD dwErr = GetLastError();
		m_iPos += dwErr==0?1:0;
		}
	else 
		m_iPos=iPos;
	}

void CMRUList :: UpdateMenu( ) { 
	int i;
	for( i=0; i<=m_iLen; ++i ) 
		if( 0==DeleteMenu( m_hMnu, m_iPos, MF_BYPOSITION ) ) 
			break;
		
	int iMenuID=m_iID-1;
	for( i=m_aItems.Count()-1; i>=0; --i ) 
		AppendMenu( m_hMnu, MF_BYPOSITION|MF_STRING, (UINT_PTR)(++iMenuID), ((CMRUItem *)m_aItems[i])->m_cName.ConstBuffer() ); 
	}

void CMRUList :: LoadList( ) { 
	int iPos;
	CString c;
	m_aItems.DeleteAll();
	c = RegistryLoadString( m_cKey.ConstBuffer() );
	while( (iPos=c.Find('\t' )) > 0 ) {
		m_aItems.AddItem( new CMRUItem( c.Left(iPos).ConstBuffer() ) ); 
		c = c.Mid(iPos+1);
		}
	}

bool CMRUList :: SaveList( ) { 
	CString c; 
	for( int i=0; i<m_aItems.Count(); ++i ) {
		c.Append( ((CMRUItem *)m_aItems[i])->m_cName.ConstBuffer() );
		c.Append( "\t" );
		}
	return RegistrySaveString( m_cKey.ConstBuffer(), c.ConstBuffer() );	
	}

void CMRUList :: AddItem( const char * pchItem ) { 
	for( int i=m_aItems.Count()-1; i>=0; --i ) 
		if( ((CMRUItem *)m_aItems[i])->m_cName == pchItem ) 
			m_aItems.DeleteItem(i);
	while( m_aItems.Count()>=m_iLen && m_iLen>0 ) 
		m_aItems.DeleteItem(0);
	m_aItems.AddItem( new CMRUItem( pchItem ) ); 
	}
	
	